天天看点

Codeforces 327A Flipping Game(区间DP,暴力枚举)

Flipping Game

Iahub got bored, so he invented a game to be played on paper.

He writes n integers a1, a2, …, an. Each of those integers can be either 0 or 1. He’s allowed to do exactly one move: he chooses two indices i and j (1 ≤ i ≤ j ≤ n) and flips all values ak for which their positions are in range [i, j] (that is i ≤ k ≤ j). Flip the value of x means to apply operation x = 1 - x.

The goal of the game is that after exactly one move to obtain the maximum number of ones. Write a program to solve the little game of Iahub.

Input

The first line of the input contains an integer n (1 ≤ n ≤ 100). In the second line of the input there are n integers: a1, a2, …, an. It is guaranteed that each of those n values is either 0 or 1.

Output

Print an integer — the maximal number of 1s that can be obtained after exactly one move.

Example

Input

5

1 0 0 1 0

Output

4

Input

4

1 0 0 1

Output

4

Note

In the first case, flip the segment from 2 to 5 (i = 2, j = 5). That flip changes the sequence, it becomes: [1 1 1 0 1]. So, it contains four ones. There is no way to make the whole sequence equal to [1 1 1 1 1].

In the second case, flipping only the second and the third element (i = 2, j = 3) will turn all numbers into 1

题意:

给定一串01序列,选择其中一段翻转,也就是0变1,1变0.求一次翻转后的最多1的数目。

思路:

暴力枚举:

用个数组储存前缀和,表示i之前1的数目,在枚举每个区间,数据比较小,也能过。

区间DP:

预处理差不多,DP[i][j]表示I到j之间一次翻转后一最多的数量。

对于每个区间而言,在中间找个断点k,一次翻转可能发生在前面I到K,也可能发生在K到j之间,

那我们就得到了状态转移方程

dp[I][j]=max(dp[i][k]+sum[j]-sum[k],dp[k+1][j]+sum[k]-sum[i-1]));

(i<=K < j)

#include<iostream>
#include<cstdio>
#include<algorithm>
#include<math.h>
#include<string.h>
#define mem(a,b)  memset((a),(b),sizeof(b));
using namespace std;


int main()
{
    ios::sync_with_stdio(false);
   // freopen("text.txt", "r", stdin);
    int a[];
    int sum[];
    int dp[][];
    int n;
    cin>>n;
    sum[]=;
    memset(dp,,sizeof(dp));
    for(int i=;i<=n;i++)
        {
            cin>>a[i];
            sum[i]=a[i]+sum[i-];
            dp[i][i]=-a[i];
        }

    for(int l=;l<n;l++)
        for(int i=;i+l<=n;i++)
    {
        int j=i+l;
        dp[i][j]=j-i+-sum[j]+sum[i-];
        for(int k=i;k<j;k++)
            dp[i][j]=max(dp[i][j],
                    max(dp[i][k]+sum[j]-sum[k],
                    dp[k+][j]+sum[k]-sum[i-]));
                    //cout<<i<<' '<<j<<' '<<dp[i][j]<<endl;
    }

    cout<<dp[][n]<<endl;
    return ;
}
           

所谓水题就是拿来练习,只有对某种方法足够熟练,有一定理解才能用起来得心应手,虽然我现在菜的不行,但坚持下去,我想会有收获的。